#ifndef CHANNELS_H
#define CHANNELS_H

//    This file is part of MRCI.

//    MRCI is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.

//    MRCI is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.

//    You should have received a copy of the GNU General Public License
//    along with MRCI under the LICENSE.md file. If not, see
//    <http://www.gnu.org/licenses/>.

#include "../common.h"
#include "table_viewer.h"

class CreateChannel : public InternCommand
{
    Q_OBJECT

public:

    static QString cmdName();

    void procBin(const SharedObjs *sharedObjs, const QByteArray &binIn, uchar dType);

    explicit CreateChannel(QObject *parent = nullptr);
};

//-----------------------

class RemoveChannel : public InternCommand
{
    Q_OBJECT

public:

    static QString cmdName();

    void procBin(const SharedObjs *sharedObjs, const QByteArray &binIn, uchar dType);

    explicit RemoveChannel(QObject *parent = nullptr);
};

//----------------------

class RenameChannel : public InternCommand
{
    Q_OBJECT

public:

    static QString cmdName();

    void procBin(const SharedObjs *sharedObjs, const QByteArray &binIn, uchar dType);

    explicit RenameChannel(QObject *parent = nullptr);
};

//------------------------

class SetActiveState : public InternCommand
{
    Q_OBJECT

public:

    static QString cmdName();

    void procBin(const SharedObjs *sharedObjs, const QByteArray &binIn, uchar dType);

    explicit SetActiveState(QObject *parent = nullptr);
};

//-------------------------

class CreateSubCh : public InternCommand
{
    Q_OBJECT

public:

    static QString cmdName();

    void procBin(const SharedObjs *sharedObjs, const QByteArray &binIn, uchar dType);

    explicit CreateSubCh(QObject *parent = nullptr);
};

//-------------------------

class RemoveSubCh : public InternCommand
{
    Q_OBJECT

public:

    static QString cmdName();

    void procBin(const SharedObjs *sharedObjs, const QByteArray &binIn, uchar dType);

    explicit RemoveSubCh(QObject *parent = nullptr);
};

//--------------------------

class RenameSubCh : public InternCommand
{
    Q_OBJECT

public:

    static QString cmdName();

    void procBin(const SharedObjs *sharedObjs, const QByteArray &binIn, uchar dType);

    explicit RenameSubCh(QObject *parent = nullptr);
};

//------------------------

class ListSubCh : public TableViewer
{
    Q_OBJECT

public:

    static QString cmdName();

    void procBin(const SharedObjs *sharedObjs, const QByteArray &binIn, uchar dType);

    explicit ListSubCh(QObject *parent = nullptr);
};

//--------------------------

class ListChannels : public TableViewer
{
    Q_OBJECT

public:

    static QString cmdName();

    void procBin(const SharedObjs *sharedObjs, const QByteArray &binIn, uchar dType);

    explicit ListChannels(QObject *parent = nullptr);
};

//----------------------------

class SearchChannels : public TableViewer
{
    Q_OBJECT

public:

    static QString cmdName();

    void procBin(const SharedObjs *sharedObjs, const QByteArray &binIn, uchar dType);

    explicit SearchChannels(QObject *parent = nullptr);
};

//------------------------------

class InviteToCh : public InternCommand
{
    Q_OBJECT

public:

    static QString cmdName();

    void procBin(const SharedObjs *sharedObjs, const QByteArray &binIn, uchar dType);

    explicit InviteToCh(QObject *parent = nullptr);
};

//-------------------------------

class DeclineChInvite : public InternCommand
{
    Q_OBJECT

public:

    static QString cmdName();

    void procBin(const SharedObjs *sharedObjs, const QByteArray &binIn, uchar dType);

    explicit DeclineChInvite(QObject *parent = nullptr);
};

//-------------------------------

class AcceptChInvite : public InternCommand
{
    Q_OBJECT

public:

    static QString cmdName();

    void procBin(const SharedObjs *sharedObjs, const QByteArray &binIn, uchar dType);

    explicit AcceptChInvite(QObject *parent = nullptr);
};

//------------------------------

class RemoveChMember : public InternCommand
{
    Q_OBJECT

public:

    static QString cmdName();

    void procBin(const SharedObjs *sharedObjs, const QByteArray &binIn, uchar dType);

    explicit RemoveChMember(QObject *parent = nullptr);
};

//------------------------------

class SetMemberLevel : public InternCommand
{
    Q_OBJECT

public:

    static QString cmdName();

    void procBin(const SharedObjs *sharedObjs, const QByteArray &binIn, uchar dType);

    explicit SetMemberLevel(QObject *parent = nullptr);
};

//------------------------------

class SetSubAcessLevel : public InternCommand
{
    Q_OBJECT

public:

    static QString cmdName();

    void procBin(const SharedObjs *sharedObjs, const QByteArray &binIn, uchar dType);

    explicit SetSubAcessLevel(QObject *parent = nullptr);
};

//-----------------------------

class ListMembers : public TableViewer
{
    Q_OBJECT

public:

    static QString cmdName();

    void procBin(const SharedObjs *sharedObjs, const QByteArray &binIn, uchar dType);

    explicit ListMembers(QObject *parent = nullptr);
};

//-----------------------------

class OwnerOverride : public InternCommand
{
    Q_OBJECT

public:

    static QString cmdName();

    void procBin(const SharedObjs *sharedObjs, const QByteArray &binIn, uchar dType);

    explicit OwnerOverride(QObject *parent = nullptr);
};

#endif // CHANNELS_H
